
   /*

         Source code for Lin-Player. 

         Written by G Rama Krishna, doing Master of Management studies, BITS
   Pilani. 

         Date of Publication : 11-12-2000.

         Completed by: 1-08-2000.

         Tested using compiler: gcc - egcs-2.91.66 (egcs- 1.1.2 release) and

         Operating system: Redhat Linux 6.1, release Cartman,

         Kernel - 2.2.12-20 on an i686.

    

         Save this file with file name *palyer.c*.

   */

    

   #include<curses.h>
   #include<time.h>
   #include<signal.h>
   #include<sys/types.h>
   #include<sys/wait.h>

   #define MAX_SONGS 100
   #define MAX_FILES 200
   #define TAB  -127
   char Home[50],*Dir,*File[MAX_FILES]={NULL};
   char t_str[100],SongTitle[100];

   typedef struct s{
               struct s* prev;
               char Title[60];
               char Path[200];
               struct s* next;
               } SONG;
   SONG *Song,*head,*tsptr,*sel_song(SONG *,int),*rem_link(int);

   short  N_song,vol,bass,treble,pcm,cur_song;
   time_t started_time,now_time;
   int total_time,frames,lag;
   WINDOW *list,*nav,*menu,*title,*status,*wbass,*wtreble,*wvol,*wpcm;
   WINDOW *werr;
   //char *option[]={"PLAY","ADD","CLEAR","EXIT"};

   main(int argc,char* argv[])
   {
   int i,Green=0;
   initscr();
   start_color();
   cbreak();
   noecho();
   curs_set(0);
   init_pair(1,COLOR_RED,COLOR_BLUE);
   init_pair(2,COLOR_YELLOW,COLOR_BLUE);
   init_pair(3,COLOR_WHITE,COLOR_BLUE);
   init_pair(4,COLOR_CYAN,COLOR_BLUE);
   init_pair(5,COLOR_MAGENTA,COLOR_BLUE);
   init_pair(6,COLOR_GREEN,COLOR_BLUE);
   strcpy(Home,argv[1]);
   Dir=(char *) malloc(strlen(Home) + 1);
   strcpy(Dir,Home);
   strcat(Dir,"/");
   check_files();
   make_screen();
   head=(SONG*) malloc(sizeof(SONG));
   head->next=NULL;
   head->prev=NULL;
   Song=head;
   mvaddch(1,1,' ');
   load_file();
   refresh();
   windows();
   filetree(-1);
   controlz();
   //player();
   getch();
   endwin();
   }

   int windows()
   {
   int i;
   list=newwin(12,35,3,3);
   wbkgd(list,COLOR_PAIR(5));
   //attron(A_BOLD);
   wborder(list,0,0,0,0,0,0,0,0);
   Song=head;
   for(i=0; i<N_song && i<10;i++)
   {
         if(i==0)
         {
               wattron(list,A_STANDOUT);
               mvwaddstr(list,i+1,1,Song->Title);
               wattroff(list,A_STANDOUT);
         }
         else
               mvwaddstr(list,i+1,1,Song->Title);
   Song=Song->next;
   }
   Song=head;
        
   wrefresh(list);
   werr=newwin(1,77,16,2);
   wbkgd(werr,COLOR_PAIR(5));
   show_error("WELCOME");
   nav=newwin(12,35,3,40);
   wbkgd(nav,COLOR_PAIR(5));
   wborder(nav,0,0,0,0,0,0,0,0);
   wrefresh(nav);

   wvol=newwin(1,31,20,3);
   wbkgd(wvol,COLOR_PAIR(3));
   waddstr(wvol,"Vol ");
   for(i=0;i<=25;i++)
         if(i==vol)
               {
               wattron(wvol,A_STANDOUT);
               mvwaddch(wvol,0,5+i,'+');
               wattroff(wvol,A_STANDOUT);
               }
         else
               mvwaddch(wvol,0,5+i,'+');
              
   wrefresh(wvol);

   wpcm=newwin(1,31,22,3);
   wbkgd(wpcm,COLOR_PAIR(3));
   waddstr(wpcm,"Pcm ");
   for(i=0;i<=25;i++)
         if(i==pcm)
               {
               wattron(wpcm,A_STANDOUT);
               mvwaddch(wpcm,0,5+i,'+');
               wattroff(wpcm,A_STANDOUT);
               }
         else
               mvwaddch(wpcm,0,5+i,'+');
              
   wrefresh(wpcm);

   wbass=newwin(1,31,20,43);
   wbkgd(wbass,COLOR_PAIR(3));
   waddstr(wbass,"Bass ");
   for(i=0;i<=25;i++)
         if(i==bass)
               {
               wattron(wbass,A_STANDOUT);
               mvwaddch(wbass,0,5+i,'+');
               wattroff(wbass,A_STANDOUT);
               }
         else
               mvwaddch(wbass,0,5+i,'+');
              
   wrefresh(wbass);

   wtreble=newwin(1,31,22,43);
   wbkgd(wtreble,COLOR_PAIR(3));
   waddstr(wtreble,"Treb ");
   for(i=0;i<=31;i++)
         if(i==treble)
               {
               wattron(wtreble,A_STANDOUT);
               mvwaddch(wtreble,0,5+i,'+');
               wattroff(wtreble,A_STANDOUT);
               }
         else
               mvwaddch(wtreble,0,5+i,'+');
              
   wrefresh(wtreble);
   /*
   menu=newwin(5,60,12,10);
   wbkgd(menu,COLOR_PAIR(1));
   wborder(menu,0,0,0,0,0,0,0,0);
   for(i=0;i<4;i++)
         if(i==0)
         {
               wattron(menu,A_BLINK);
               mvwaddstr(menu,2,10+i*10,option[i]);
               wattroff(menu,A_BLINK);
         }
         else
               mvwaddstr(menu,2,10+i*10,option[i]);
   wrefresh(menu);
   */

   status=newwin(1,70,18,2);
   wbkgd(status,COLOR_PAIR(2));
   wattron(status,A_BOLD);
   title=newwin(1,78,2,1);
   wbkgd(title,COLOR_PAIR(6));
   }

int load_file()
{
   FILE *fptr;
   int i;
   sprintf(t_str,"%s/.rplaylist",Home);      //Play list
   fptr=fopen(t_str,"r");

   while(!feof(fptr))
   {
   fscanf(fptr,"%[^|]",t_str);
   if(feof(fptr))
         break;
   if(Song==NULL)
         {
         add_link(tsptr);
         Song=tsptr->next;
         }
   strcpy(Song->Title,t_str);
   fgetc(fptr);
   fscanf(fptr,"%[^\n]",t_str);
   fgetc(fptr);
   if(feof(fptr))
         break;
   strcpy(Song->Path,t_str);
   tsptr=Song;
   Song=Song->next;
   N_song++;
   }
   fclose(fptr);

   sprintf(t_str,"%s/.rplaytemp",Home);
   system("/usr/bin/aumix -q|grep vol|sed 's/[^0-9 ]//g' >$HOME/.rplaytemp");
   fptr=fopen(t_str,"r");
   fscanf(fptr,"%d",&vol);
   fclose(fptr);
   system("/usr/bin/aumix -q|grep bass|sed 's/[^0-9 ]//g'>$HOME/.rplaytemp");
   fptr=fopen(t_str,"r");
   fscanf(fptr,"%d",&bass);
   fclose(fptr);
   system("/usr/bin/aumix -q|grep treble|sed 's/[^0-9 ]//g'>$HOME/.rplaytemp");
   fptr=fopen(t_str,"r");
   fscanf(fptr,"%d",&treble);
   fclose(fptr);
   system("/usr/bin/aumix -q|grep pcm|sed 's/[^0-9 ]//g' >$HOME/.rplaytemp");
   fptr=fopen(t_str,"r");
   fscanf(fptr,"%d",&pcm);
   fclose(fptr);
   /*
   for(i=0;i<N_song;i++)
   {
   addstr(Song[i]);
   addstr(Path[i]);
   addch('\n');
   }
   */
   //sprintf(t_str,"%d %d %d %d",vol,pcm,bass,treble);
   //addstr(t_str);
   vol=vol/4;
   treble=treble/4;
   bass=bass/4;
   pcm=pcm/4;
   //sprintf(t_str,"%d %d %d %d",vol,pcm,bass,treble);
   //addstr(t_str);
}

   int make_screen()
   {
   bkgd(COLOR_PAIR(3));
   border(0,0,0,0,0,0,0,0);
   attron(A_BOLD);
   mvaddstr(0,2,"Lin-player");
   attroff(A_BOLD);
   mvaddstr(24,56,"Rama Krishna Gaddipati");
   return(1);
   }

int check_files()
{
	FILE *fptr;
              
   sprintf(t_str,"%s/.rplaylist",Home);      //Play list
   fptr=fopen(t_str,"r");
   if(fptr==NULL)
   {
         addstr("File not-existing\n");
         fptr=fopen(t_str,"w");
         fclose(fptr);
         return(1);
   }
   return(0);
}

int filetree(int opt)
{
   FILE *fptr;
   int n_file=0,choice,i;
   while(1)
   {
   n_file=0;
   sprintf(t_str,"ls -aF \"%s\" |grep /> $HOME/.rplaytemp",Dir);
   system(t_str);
   sprintf(t_str,"ls -aF \"%s\" |grep -v /|sed 's/[*/=@|]//g' >>$HOME/.rplaytemp",Dir);
   system(t_str);
   sprintf(t_str,"%s/.rplaytemp",Home);

   fptr=fopen(t_str,"r");

   while(!feof(fptr))
   {
   fscanf(fptr,"%[^\n]",t_str);
   if(feof(fptr)) break;
   fgetc(fptr);
   File[n_file]=(char *) realloc(File[n_file],strlen(t_str)+1);
   strcpy(File[n_file],t_str);
   if(n_file<10)
   mvwaddstr(nav,n_file+1,2,File[n_file]);
   n_file++;
   }
   fclose(fptr);

   wrefresh(nav);
   if(opt==-1 && N_song)
         {
         mvwaddch(nav,0,1,ACS_HLINE);
         mvwaddch(nav,0,2,ACS_HLINE);
         mvwaddch(nav,0,3,ACS_HLINE);
         wrefresh(nav);
         return(0);
         }
   if(!N_song)
         opt=1;     
   choice=selection(nav,File,n_file,opt)-1;
   if(choice+1==0 || choice+1==TAB)
         {
         mvwaddch(nav,0,2,ACS_HLINE);
         wrefresh(nav);
         return(choice+1);
         }
   if(File[choice][strlen(File[choice])-1]=='/')
         {
         if(!strcmp(File[choice],"../"))
               for(i=strlen(Dir)-2;i>0;i--)
                     if(Dir[i]!='/')
                           Dir[i]='\0';
                     else
                           break;
         else
               strcat(Dir,File[choice]);
         }
   else
         {
         sprintf(t_str,"%s/.rplaylist",Home);
         fptr=fopen(t_str,"a");
         fprintf(fptr,"%s|%s%s\n",File[choice],Dir,File[choice]);
         fclose(fptr);
         if(head==NULL)
               {
               head=(SONG*) malloc(sizeof(SONG));
               head->prev=NULL;
               head->next=NULL;
               }
         tsptr=head;
         if(N_song)
         {
         while(tsptr->next!=NULL)
               tsptr=tsptr->next;
         add_link(tsptr);
         tsptr=tsptr->next;
         }
         strcpy(tsptr->Title,File[choice]);
         strcpy(tsptr->Path,Dir);
         strcat(tsptr->Path,File[choice]);
         addtolist();
         /*
         Song[N_song]=(char *)realloc(Song[N_song],strlen(File[choice])+1);
         Path[N_song]=(char
   *)realloc(Path[N_song],strlen(File[choice])+strlen(Dir)+3);
         strcpy(Song[N_song],File[choice]);
         strcpy(Path[N_song],Dir);
         strcat(Path[N_song],File[choice]);
         Song[N_song][strlen(File[choice])]='\0';
         Path[N_song][strlen(File[choice]) + strlen(Dir) ]='\0';
         if(N_song<10)
         {
               mvwaddstr(list,N_song+1,1,File[choice]);
               wrefresh(list);
         }    
         */

         N_song++;
         }
                          
   }     //while(1)
   mvaddstr(0,0,"                                  ");
   mvaddstr(0,0,"DONE..............!!!!!!!!!!!!!!!!");
   getch();
}

int player(int option)
{
   int min=0,sec=0;
   static choice;
   FILE *fptr;
   if(!option)
         {
         if(Song!=NULL)
         {
         if(Song->next==NULL)
               tsptr=sel_song(head,-1);
         else
               tsptr=sel_song(head,0);
         }
         else
               {
               filetree(1);
               tsptr=sel_song(head,-1);
               }

         if(tsptr!=NULL)
               Song=tsptr;
         else
               return(0);
         }
   else
         if(option==-1 && N_song)
               {
               Song=head;
               }
         else
               if(N_song && Song!=NULL)
                     Song=Song->next;
               else
                     return(0);
   if(Song==NULL)
         return(0);
   sprintf(t_str,"mpg123.rpl -q \"%s\" 2> $HOME/.rplaytemp &",Song->Path);
   system("killer mpg123.rpl");
   system(t_str);
   sprintf(t_str,"rlxtract \"%s\"",Song->Path);
   system(t_str);
   sprintf(t_str,"%s/.rplaytemp",Home);
   fptr=fopen(t_str,"r");
   fscanf(fptr,"%d",&min);
   fscanf(fptr,"%d",&sec);
   //fscanf(fptr,"%s",t_str);
   fclose(fptr);
   total_time= min*60+ sec;
   time(&started_time);
   lag=0;
   cur_song=choice;
   sprintf(t_str,"rlframe \"%s\"",Song->Path);
   system(t_str);
   sprintf(t_str,"%s/.rplaytemp",Home);
   fptr=fopen(t_str,"r");
   fscanf(fptr,"%d",&frames);
   fclose(fptr);
   strcpy(SongTitle,Song->Title);
}

SONG *sel_song(SONG *startptr,int opt)
{
   SONG *song,*sel;
   int pos=0,i=0,n_song=0,k,ch,start=0,count=0;
   int mode=0;
   keypad(list,TRUE);
                     wattron(list,A_BOLD);
   while(1)
   {
   song=head;
   n_song=0;
   werase(list);
                     if(mode)
                           wattroff(list,A_BOLD);
   wborder(list,0,0,0,0,0,0,0,0);
   i=0;
         while(song!=NULL && i<10) {
         	if(n_song<start) {
               		song=song->next;
               		n_song++;
               		continue;
               	}
         if(pos==i && !mode)
         {
               wattron(list,COLOR_PAIR(3));
               for(k=0;k<32 && k<strlen(song->Title);k++)
                     mvwaddch(list,i+1,1+k,song->Title[k]);
               wattroff(list,COLOR_PAIR(3));
         }
         else
               for(k=0;k<32 && k<strlen(song->Title);k++)
                     mvwaddch(list,i+1,1+k,song->Title[k]);
         i++; 
         song=song->next;
         }
   switch(mode)
   {
         case 1:
               wrefresh(list);
               return(sel);
         case 2:
               wrefresh(list);
               return(NULL);
   }
   ch=wgetch(list);
   if(opt!=-1)
   if(ch==ERR)
         {
         count++;
         if(count>50)
               mode=2;
               //return(NULL);
         else
               continue;
         }
   else
         count=0;
   switch(ch)
   {
         case KEY_UP:      if(pos)
                           pos--;
                     if(pos==0 && start)
                           start--;
                     break;
         case KEY_DOWN :
                     if(pos<9 && pos<N_song-1)
                           pos++;
                     if(pos==9 && start<N_song-10)            
                           start++;
                     break;
         case '+':
                     if(move_up(start+pos));
                           pos--;
                     break;
         case '-':
                     if(move_up(start+pos+1));
                           pos++;
                     break;
         case 'd':
         case 'D':
                     if(N_song==0)
                           break;
                     rem_link(start+pos);
                     N_song--;
                     if(start+pos>=N_song)
                           pos--;
                     if(pos<0 && start)
                           {
                           pos=0;
                           start--;
                           }
                     break;
         case 'r':
         case 'R':
                     rename_song(start+pos);
                     break;
         case '\n':
                     song=head;
                     i=0;
                     while(i!=start+pos)
                     {
                     song=song->next;
                     i++;
                     }
                     mode=1;
                     sel=song;
                     //return(song);
                     break;
         case '':
                     mode=2;
                     return(NULL);
                     break;
	}
   }

}

   int selection(WINDOW *win,char *string[],int n_string,int option)
   {
   static pos,start;
   int i,k,ch,count=0;
   if(pos>=n_string)
   pos=n_string-1;
   if(start>=n_string-10)
   start=0;
   keypad(win,TRUE);
   while(1)
   {
   werase(win);
   wborder(win,0,0,0,0,0,0,0,0);
   wattron(win,A_BOLD);
   mvwaddstr(win,0,1,"(*)");
   wattroff(win,A_BOLD);
   for(i=0;i<10 && i<n_string;i++)
   {
         if(pos==i)
         {
               wattron(win,A_STANDOUT);
               for(k=0;k<32 && k<strlen(string[start+i]);k++)
                     mvwaddch(win,i+1,1+k,string[start+i][k]);
               //mvwaddstr(win,i+1,1,string[start+i]);
               wattroff(win,A_STANDOUT);
         }
         else
               for(k=0;k<32 && k<strlen(string[start+i]);k++)
                     mvwaddch(win,i+1,1+k,string[start+i][k]);
               //mvwaddstr(win,i+1,1,string[start+i]);
   }
   ch=wgetch(win);
   if(ch==ERR)
         count++;
   else
         count=0;
   if(count==100 && !option)
         return(0);
   switch(ch)
   {
         case KEY_UP:      if(pos)
                           pos--;
                     if(pos==0 && start)
                           start--;
                     break;
         case KEY_DOWN :
                     if(pos==9 && start<n_string-10)                
                           start++;
                     if(pos<9 && pos<n_string-1)
                           pos++;
                     break;
         case '\n':
                     return(start+pos+1);
         case '':
                     return(0);
         case '\t':
                     if(!option)
                     return(TAB);
   }     //switch
   }     //while
   }

   int controlz()
   {
   int ch;
   static int i,diff,pos,changed;
   char tag[10];
   float percent=0;
   char tab_pos[]={"LFVPBT"};
   static tab,istab;

   halfdelay(1);
   keypad(status,TRUE);

   player(-1);
   help_controlz();

   while(1)
   {

   time(&now_time);

   diff=lag+(int)difftime(now_time,started_time);

   percent=((float)diff)/total_time*100;

   if(percent>100)
   {
         lag=0;
         if(N_song==0||Song->next==NULL)
               {
               if(!N_song)
                     show_error("PLAY LIST IS EMPTY");
               else
                     show_error("SELECT A SONG");
               if(N_song==0)
                     filetree(1);
               player(0);
               clear_error();
               }
         else
               player(1);
         continue;
   }
   sprintf(tag,"%6.2f%%",percent);
   mvwaddstr(status,0,55,tag);
   for(i=0;i<50;i++)
   {
         if(i<percent/2)
               {
               wattron(status,A_STANDOUT);
               mvwaddch(status,0,i,'+');
               wattroff(status,A_STANDOUT);
               }
         else
               mvwaddch(status,0,i,'+');

   }
   if(!changed)
         pos=percent/2;
   mvwaddch(status,0,pos,'|');
   wrefresh(status);
   show_title();

   if(!istab)
         ch=wgetch(status);
   else
         {
         ch='\t';
         istab=0;
         }

   if(ch=='\t')
         {
         if(tab>=6)
               tab=0;
         ch=tab_pos[tab];
         tab++;
         }
   switch(toupper(ch))
   {
         case 'H':
               help_controlz();
               break;
         case 'L':
               help_player();
               if(player(0)==TAB)
                     istab=1;
               help_controlz();
               tab=1;
               break;
         case 'F':
               if(filetree(0)==TAB)
                     istab=1;
               help_controlz();
               tab=2;
               break;
         case 'B':
               if(bass_control()==TAB)
                     istab=1;
               tab=3;
               break;           
         case 'V':
               if(volume_control()==TAB)
                     istab==1;
               tab=4;
               break;
         case 'P':
               if(pcm_control()==TAB)
                     istab=1;
               tab=5;
               break;
         case 'T':
               if(treble_control()==TAB)
                     istab=1;
               tab=6;
               break;
         case '+':
               if(!N_song)
                     break;
               if(strcmp(Song->Title,SongTitle) && N_song)
                     {
                     lag=0;
                     player(-1);
                     }
               else
               if(Song->next!=NULL)
                     {
                     lag=0;
                     player(1);
                     }
               break;
         case '-':
               if(!N_song)
                     break;
               if(strcmp(Song->Title,SongTitle) && N_song)
                     {
                     lag=0;
                     player(-1);
                     }
               else
               if(Song->prev!=NULL)
                     if(Song->prev->prev!=NULL)
                     {
                           Song=Song->prev->prev;
                           lag=0;
                           player(1);
                     }
                     else
                           {
                           lag=0;
                           player(-1);
                           }
               break;
         case 'X':
               exiter();
               break;
         case 'S':
               {
               pid_t pid;
               def_prog_mode();
               sprintf(t_str,"%s/.rplayscr",Home);
               scr_dump(t_str);
               reset_shell_mode();
               endwin();
               pid=fork();

               if(pid)
                     {
                     system("bash");
                     kill(pid,SIGKILL);
                     }
               else
                     {
                     while(!system("ps|grep -q mpg123.rpl 2> $HOME/.rplaytemp"));
                     Song=Song->next;
                     while(Song!=NULL)
                     {
                     sprintf(t_str,"mpg123.rpl -q \"%s\" 2>~/.rplaytemp",Song->Path);
                     system(t_str);
                     Song=Song->next;
                     }
                     }
               scr_set(t_str);
               doupdate();
               curs_set(0);
               }
               break;
         case 'A':
               {
               pid_t pid;
               def_prog_mode();
               sprintf(t_str,"%s/.rplayscr",Home);
               scr_dump(t_str);
               reset_shell_mode();
               endwin();
               pid=fork();

               if(pid)
                     {
                     system("about.rpl");
                     kill(pid,SIGKILL);
                     }
               else
                     {
                     while(!system("ps|grep -q mpg123.rpl 2> $HOME/.rplaytemp"));
                     Song=Song->next;
                     while(Song!=NULL)
                     {
                     sprintf(t_str,"mpg123.rpl -q \"%s\" 2>~/.rplaytemp",Song->Path);
                     system(t_str);
                     Song=Song->next;
                     }
                     }
               scr_set(t_str);
               doupdate();
               curs_set(0);
               }
               break;
         case 'R':
               refreshall();
               break;
        
         case KEY_LEFT :
               changed=1;
               if(pos)
                     pos--;
               break;
         case KEY_RIGHT :
               changed=1;
               if(pos<50)
                     pos++;
               break;
         case '\n':
               if(!changed)
                     break;
               changed=0;
               lag=(pos*total_time)/50;
               sprintf(t_str,"mpg123.rpl -q -k %d \"%s\" 2> $HOME/.rplaytemp &",(pos*frames)/50,Song->Path);
               system("killer mpg123.rpl");
               system(t_str);
               time(&started_time);
               break;
              
   }     //switch
   }     //while

   }

   int bass_control()
   {
   int ch,i,count=0;
   keypad(wbass,TRUE);
   nodelay(wbass,TRUE);
   wattron(wbass,COLOR_PAIR(1));
   mvwaddstr(wbass,0,0,"Bass ");
   wattroff(wbass,COLOR_PAIR(1));
   wrefresh(wbass);
   while(1)
   {
   ch=wgetch(wbass);
   if(ch==ERR)
         count++;
   if(count==50)
         {
         mvwaddstr(wbass,0,0,"Bass ");
         wrefresh(wbass);
         return(0);
         }
   switch(ch)
   {
         case '-':
         case KEY_DOWN:
         case KEY_LEFT:
                     if(bass)
                           bass--;
                     break;
         case '+':
         case KEY_UP:
         case KEY_RIGHT:
                     if(bass<25)
                           bass++;
                     break;
         case '':
                     mvwaddstr(wbass,0,0,"Bass ");
                     wrefresh(wbass);
                     return(0);
         case '\t':
                     mvwaddstr(wbass,0,0,"Bass ");
                     wrefresh(wbass);
                     return(TAB);
   }
                     sprintf(t_str,"aumix -b %d 2>$HOME/.rplaytemp &",bass*4);
                     system(t_str);
   for(i=0;i<26;i++)
   {
         if(i==bass)
               {
                     wattron(wbass,A_STANDOUT);
                     mvwaddstr(wbass,0,5+i,"+");
                     wattroff(wbass,A_STANDOUT);
               }
         else
                     mvwaddstr(wbass,0,5+i,"+");
   }    

   }
   }

   int pcm_control()
   {
   int ch,i,count=0;
   keypad(wpcm,TRUE);
   nodelay(wpcm,TRUE);
   wattron(wpcm,COLOR_PAIR(1));
   mvwaddstr(wpcm,0,0,"Pcm ");
   wattroff(wpcm,COLOR_PAIR(1));
   wrefresh(wpcm);
   while(1)
   {
   ch=wgetch(wpcm);
   if(ch==ERR)
         count++;
   if(count==50)
         {
         mvwaddstr(wpcm,0,0,"Pcm ");
         wrefresh(wpcm);
         return(0);
         }
   switch(ch)
   {
         case '-':
         case KEY_DOWN:
         case KEY_LEFT:
                     if(pcm)
                           pcm--;
                     break;
         case '+':
         case KEY_UP:
         case KEY_RIGHT:
                     if(pcm<25)
                           pcm++;
                     break;
         case '':
                     mvwaddstr(wpcm,0,0,"Pcm ");
                     wrefresh(wpcm);
                     return(0);
         case '\t':
                     mvwaddstr(wpcm,0,0,"Pcm ");
                     wrefresh(wpcm);
                     return(TAB);
   }
                     sprintf(t_str,"aumix -w %d 2>$HOME/.rplaytemp &",pcm*4);
                     system(t_str);
   for(i=0;i<26;i++)
   {
         if(i==pcm)
               {
                     wattron(wpcm,A_STANDOUT);
                     mvwaddstr(wpcm,0,5+i,"+");
                     wattroff(wpcm,A_STANDOUT);
               }
         else
                     mvwaddstr(wpcm,0,5+i,"+");
   }    

   }
   }

   int volume_control()
   {
   int ch,i,count=0;
   keypad(wvol,TRUE);
   nodelay(wvol,TRUE);
   wattron(wvol,COLOR_PAIR(1));
   mvwaddstr(wvol,0,0,"Vol ");
   wattroff(wvol,COLOR_PAIR(1));
   wrefresh(wvol);
   while(1)
   {
   ch=wgetch(wvol);
   if(ch==ERR)
         count++;
   if(count==50)
         {
         mvwaddstr(wvol,0,0,"Vol ");
         wrefresh(wvol);
         return(0);
         }

   switch(ch)
   {
         case '-':
         case KEY_DOWN:
         case KEY_LEFT:
                     if(vol)
                           vol--;
                     break;
         case '+':
         case KEY_UP:
         case KEY_RIGHT:
                     if(vol<25)
                           vol++;
                     break;
         case '':
                     mvwaddstr(wvol,0,0,"Vol ");
                     wrefresh(wvol);
                     return(0);
         case '\t':
                     mvwaddstr(wvol,0,0,"Vol ");
                     wrefresh(wvol);
                     return(TAB);
   }
   sprintf(t_str,"aumix -v %d 2>$HOME/.rplaytemp &",vol*4);
   system(t_str);
   for(i=0;i<26;i++)
   {
         if(i==vol)
               {
                     wattron(wvol,A_STANDOUT);
                     mvwaddstr(wvol,0,5+i,"+");
                     wattroff(wvol,A_STANDOUT);
               }
         else
                     mvwaddstr(wvol,0,5+i,"+");
   }    

   }
   }

   int treble_control()
   {
   int ch,i,count=0;
   keypad(wtreble,TRUE);
   nodelay(wtreble,TRUE);
   wattron(wtreble,COLOR_PAIR(1));
   mvwaddstr(wtreble,0,0,"Treb ");
   wattroff(wtreble,COLOR_PAIR(1));
   wrefresh(wtreble);
   while(1)
   {
   ch=wgetch(wtreble);
   if(ch==ERR)
         count++;
   if(count==50)
         {
         mvwaddstr(wtreble,0,0,"Treb ");
         wrefresh(wtreble);
         return(0);
         }
   switch(ch)
   {
         case '-':
         case KEY_DOWN:
         case KEY_LEFT:
                     if(treble)
                           treble--;
                     break;
         case '+':
         case KEY_UP:
         case KEY_RIGHT:
                     if(treble<25)
                           treble++;
                     break;
         case '':
                     mvwaddstr(wtreble,0,0,"Treb ");
                     wrefresh(wtreble);
                     return(0);
         case '\t':
                     mvwaddstr(wtreble,0,0,"Treb ");
                     wrefresh(wtreble);
                     return(TAB);

   }
                     sprintf(t_str,"aumix -t %d 2>$HOME/.rplaytemp &",treble*4);
                     system(t_str);
   for(i=0;i<26;i++)
   {
         if(i==treble)
               {
                     wattron(wtreble,A_STANDOUT);
                     mvwaddstr(wtreble,0,5+i,"+");
                     wattroff(wtreble,A_STANDOUT);
               }
         else
                     mvwaddstr(wtreble,0,5+i,"+");
   }    

   }
   }

   int show_title()
   {
   static start;
   int pos,len,i;
   len=strlen(SongTitle);
   if(start>=len)
         start=-4;
   for(i=start,pos=1;pos<79;pos++)
   {
         if(i==len)
               i= -4;
         if(i<0)
               mvwaddch(title,0,pos,' ');
         else
               mvwaddch(title,0,pos,SongTitle[i]);
         i++;
   }
   wrefresh(title);
   start++;
   }

   int add_link(SONG *song)
   {
   SONG *tptr;
   tptr=song->next;
   song->next=(SONG *) malloc(sizeof(SONG));
   song->next->next=tptr;
   if(tptr!=NULL)
         tptr->prev=song->next;
   song->next->prev=song;
   return(0);
   }

   SONG* rem_link(int num)
   {
   SONG *tptr,*song;
   int i=0;
   song=head;
   while(i<num)
   {
   song=song->next;
   i++;
   }
   if(song==head)
         head=song->next;
   tptr=song->next;
   if(song->prev!=NULL)
         song->prev->next=song->next;
   if(song->next!=NULL)
         song->next->prev=song->prev;
   free(song);
   return(tptr);
   }

   int move_up(int num)
   {
   SONG *tptr1,*tptr2;
   int i=0;
   tptr2=head;
   if(num>=N_song)
         return(0);
   while(i<num)
   {
   tptr2=tptr2->next;
   if(tptr2==NULL)
         return(0);
   i++; 
   }
   tptr1=tptr2->prev;
   if(tptr1==NULL || tptr2==NULL)
         return(0);
   if(tptr1==head)
         head=tptr2;
   if(tptr1->prev!=NULL)
         tptr1->prev->next=tptr2;
   if(tptr2->next!=NULL)
         tptr2->next->prev=tptr1;
   tptr2->prev=tptr1->prev;
   tptr1->next=tptr2->next;
   tptr2->next=tptr1;
   tptr1->prev=tptr2;
   return(1);
   }

   int addtolist()
   {
   int pos=0,i=0,k=0;
   SONG *tsptr;
   pos=N_song-9>0?N_song-9:0;
   tsptr=head;
   while(i<pos)
   {
   tsptr=tsptr->next;
   i++;
   }
   werase(list);
   wborder(list,0,0,0,0,0,0,0,0);
   for(i=0;pos<=N_song;pos++,i++)
   {
         for(k=0;k<32 && k<strlen(tsptr->Title);k++)
               mvwaddch(list,i+1,1+k,tsptr->Title[k]);
         tsptr=tsptr->next;
   }
   wrefresh(list);
   }

   int exiter()
   {
   FILE *fptr;
   sprintf(t_str,"%s/.rplaylist",Home);
   fptr=fopen(t_str,"w");
   tsptr=head;
   while(tsptr!=NULL)
   {
   fprintf(fptr,"%s|%s\n",tsptr->Title,tsptr->Path);
   tsptr=tsptr->next;
   }
   endwin();
   system("killer mpg123.rpl");
   exit(0);
   }

   int refreshall()
   {
   erase();
   make_screen();
   refresh();
   //windows();
   wrefresh(list);
   wrefresh(nav);
   wrefresh(status);
   wrefresh(wvol);
   wrefresh(wpcm);
   wrefresh(wbass);
   wrefresh(wtreble);
   }

   int rename_song(int snum)
   {
   WINDOW *wrename;
   wrename=newwin(7,50,5,15);
   wborder(wrename,0,0,0,0,0,0,0,0);
   wbkgd(wrename,COLOR_PAIR(1));
   mvwaddch(wrename,4,0,ACS_VLINE);
   whline(wrename,0,48);
   nocbreak();
   wgetch(wrename);
   cbreak();
   halfdelay(1);
   werase(wrename);
   touchwin(nav);
   touchwin(list);
   return(0);
   }
   /*
   WINDOW *wglow;
   int glow(WINDOW *win)
   {
   wglow=newwin(win->_maxy+3,win->_maxx+3,win->_begy-1,win->_begx-1);
   wborder(wglow,0,0,0,0,0,0,0,0);
   wrefresh(wglow);
   wrefresh(win);
   }

   int glowoff(WINDOW *win)
   {
   werase(wglow);
   //wrefresh(win);
   refreshall();
   }
   */

   int help_controlz()
   {
   WINDOW *whelp;
   whelp=newwin(12,35,3,40);
   wborder(whelp,0,0,0,0,0,0,0,0);
   wbkgd(whelp,COLOR_PAIR(5));
   mvwaddstr(whelp,0,2,"HELP - Main Menu");
   mvwaddstr(whelp,1,2,"  - Play list");
   mvwaddstr(whelp,1,20,"  - Add File");
   mvwaddstr(whelp,2,2,"  - Volume ");
   mvwaddstr(whelp,2,20,"  - Pcm ");
   mvwaddstr(whelp,3,2,"  - Bass ");
   mvwaddstr(whelp,3,20,"  - Treble ");
   mvwaddstr(whelp,4,2,"  - Help ");
   mvwaddstr(whelp,4,20,"  - Exit ");
   mvwaddstr(whelp,5,2,"  - Linux Shell" );
   mvwaddstr(whelp,5,20,"  - Refresh" );
   mvwaddstr(whelp,6,2,"  - About Lin-Player" );
   mvwaddstr(whelp,7,2,"    - Move Between Ctrlz");
   mvwaddstr(whelp,9,2," /  - Next/Previous Song ");
   mvwaddstr(whelp,10,2," / / /  +       - Position Seek");
   mvwaddch(whelp,8,0,ACS_VLINE);
   whline(whelp,0,33);
   wattron(whelp,COLOR_PAIR(3));
   //wattron(whelp,A_BOLD);
   mvwaddch(whelp,1,2,'L');
   mvwaddch(whelp,1,20,'F');
   mvwaddch(whelp,2,2,'V');
   mvwaddch(whelp,2,20,'P');
   mvwaddch(whelp,3,2,'B');
   mvwaddch(whelp,3,20,'T');
   mvwaddch(whelp,4,2,'H');
   mvwaddch(whelp,4,20,'X');
   mvwaddch(whelp,5,2,'S');
   mvwaddch(whelp,5,20,'R');
   mvwaddch(whelp,6,2,'A');
   mvwaddstr(whelp,7,2,"Tab");
   mvwaddch(whelp,9,2,'+');
   mvwaddch(whelp,9,4,'-');
   mvwaddch(whelp,10,2,ACS_DARROW);
   mvwaddch(whelp,10,4,ACS_UARROW);
   mvwaddch(whelp,10,6,ACS_LARROW);
   mvwaddch(whelp,10,8,ACS_RARROW);
   mvwaddstr(whelp,10,12,"Enter");
   wattroff(whelp,A_BOLD);
   wrefresh(whelp);
   }

   int help_player()
   {
   WINDOW *whelp;
   whelp=newwin(12,35,3,40);
   wborder(whelp,0,0,0,0,0,0,0,0);
   wbkgd(whelp,COLOR_PAIR(5));
   mvwaddstr(whelp,0,2,"HELP - Play List");
   mvwaddstr(whelp,2,7,"- Select Song ");
   mvwaddstr(whelp,3,7,"- Move Between Songs ");
   mvwaddstr(whelp,4,7,"- Move song Up ");
   mvwaddstr(whelp,5,7,"- Move song Down " );
   mvwaddstr(whelp,6,7,"- Delete song " );
   mvwaddstr(whelp,7,7,"- Rename a song ");
   mvwaddstr(whelp,8,7,"- Main Menu ");
   wattron(whelp,COLOR_PAIR(3));
   //wattron(whelp,A_BOLD);
   mvwaddstr(whelp,2,2,"Enter");
   mvwaddch(whelp,3,2,ACS_UARROW);
   mvwaddch(whelp,3,4,ACS_DARROW);
   mvwaddch(whelp,4,2,'+');
   mvwaddch(whelp,5,2,'-');
   mvwaddch(whelp,6,2,'D');
   mvwaddch(whelp,7,2,'R');
   mvwaddstr(whelp,8,2,"Esc");
   wattroff(whelp,A_BOLD);
   wrefresh(whelp);
   }

   int show_error(char *str)
   {
   int len,pos;
   len=strlen(str);
   pos=(76-len)/2-1;
   werase(werr);
   mvwaddstr(werr,0,pos,str);
   wrefresh(werr);
   return(0);
   }
   int clear_error()
   {
   werase(werr);
   wrefresh(werr);
   }
