#include <curses.h>

#include "string_dlist.h"

extern void* animation_vline(void*);
enum {up ,down};


main(int argc, char *argv[])
{
	char *str1 = "Rama Krishna Gaddipati:-)";
	char *str2 = "LinPlayer 1.2";
	char *str3 = "Ramu Chal Basha Suman Prasanthi Hema Suresh Rafi";
	char *str4 = "rk_gaddipati@yahoo.com !@!#";

	char buf[4][100];	
	pthread_t	t1,t2,t3,t4;
	string_dlist_t	*list,*tlist,*blist,*tlist2;
	int 		ch,dir,i;
	WINDOW		*win,*whead,*wfoot;
	int 		height=10,width=45;
	char		*tstr,ypos,tlen;
	/*
	 if(argc <2) {
		fprintf(stderr,"Usage: %s <filename>\n",argv[0]);
		exit(1);
	}
	*/
	if(argc >= 2)
		list = file2strdlist(argv[1]);
	else
		list = file2strdlist("about.txt");
	if(!list) {
		fprintf(stderr,"Unable to Open file %s\n",argv[1]);
		exit(2);
	}
	
	initscr();
	start_color();
	cbreak();
	noecho();
	curs_set(0);

	height = stdscr->_maxy/2;
	width = stdscr->_maxx/2+5;

	init_pair(1,COLOR_RED,COLOR_BLACK);
	init_pair(2,COLOR_BLUE,COLOR_BLACK);
	init_pair(3,COLOR_GREEN,COLOR_BLACK);

	whead = newwin(2,stdscr->_maxx+1,0,0);
	wbkgdset(whead,COLOR_PAIR(1)|A_REVERSE);
	whline(whead,' ',whead->_maxx+1);
	mvwaddch(whead,1,0,' ');
	whline(whead,' ',whead->_maxx);
	wrefresh(whead);

	wfoot = newwin(2,stdscr->_maxx+1,stdscr->_maxy-1,0);
	wbkgdset(wfoot,COLOR_PAIR(2)|A_REVERSE);
	whline(wfoot,' ',wfoot->_maxx+1);
	mvwaddch(wfoot,1,0,' ');
	whline(wfoot,' ',wfoot->_maxx);
	wrefresh(wfoot);

	sprintf(buf[0],"%d %d %d 230 1 %s\n", 2, 2, stdscr->_maxy-4, str1);	
	sprintf(buf[1],"%d %d %d 190 2 %s\n", 4, stdscr->_maxx-2, \
			stdscr->_maxy-6, str2);	
	sprintf(buf[2],"%d %d %d 70 2 %s\n", stdscr->_maxy/4,\
			(stdscr->_maxx-width)/4 , stdscr->_maxy/2, str3);	
	sprintf(buf[3],"%d %d %d 140 1 %s\n", 3,(stdscr->_maxx+width)/2+3 ,\
		       	stdscr->_maxy-9, str4);	
	if(pthread_create(&t1,NULL,animation_vline,(void*)buf[0])) {
		fprintf(stderr,"Unable Create Pthread!\n");
	}
	
	if(pthread_create(&t2,NULL,animation_vline,(void*)buf[1])) {
		fprintf(stderr,"Unable Create Pthread!\n");
	}
	if(pthread_create(&t3,NULL,animation_vline,(void*)buf[2])) {
		fprintf(stderr,"Unable Create Pthread!\n");
	}
	
	if(pthread_create(&t4,NULL,animation_vline,(void*)buf[3])) {
		fprintf(stderr,"Unable Create Pthread!\n");
	}
	pthread_detach(t1);
	pthread_detach(t2);
	pthread_detach(t3);
	pthread_detach(t4);

	tlist = list;
	dir = up;
	win = newwin(height,width,(stdscr->_maxy+1-height)/2+1,\
			(stdscr->_maxx+1-width)/2+1);
	scrollok(win,TRUE);
	blist = tlist;
	wattrset(win,COLOR_PAIR(3));	
	for(ypos=0;ypos<height;ypos++) {
		tlen = strlen(blist->str);
		for(i=0;i<tlen;i++) {
			mvwaddch(win,ypos,i,blist->str[i]);
			napms(50);
			wrefresh(win);
		}
		blist = blist->next;
	}
	nodelay(win,TRUE);
	while(1) {
		ch = wgetch(win);
		if(toupper(ch)=='X')
			break;
		if(dir==up) {
		       if(blist->next) {
			       tlist=tlist->next;
			       blist=blist->next;
			       wscrl(win,1);
			       //mvwaddstr(win,height-1,0,blist->str);
			       ypos=height-1;
			       tstr=blist->str;
		       }
		       else
			       dir = down;
		} else {
			if(tlist->prev) {
				tlist=tlist->prev;
				blist=blist->prev;
			        wscrl(win,-1);
			        mvwaddstr(win,0,0,tlist->str);
				ypos=0;
				tstr=tlist->str;
			}
			else
				dir = up;
		}
		tlen =strlen(tstr);
		for(i=0;i<tlen;i++) {
			mvwaddch(win,ypos,i,tstr[i]);
			napms(50);
			wrefresh(win);
		}
		//wrefresh(win);
	}
	curs_set(1);
	endwin();
}

void* animation_vline(void* arg)
{
	char	str[100];
	int 	len,i,wpos,p_i,p_wpos,strtop;
	int	row,col,wlen,nap,color;
	WINDOW	*win;
	/*
	 * Argument format expected:
	 * "row col wlen nap color str\n"
	 */
	sscanf((char*)arg,"%d %d %d %d %d %[^\n]",&row,&col,&wlen,&nap,\
			&color,str);
	len = strlen(str);
	win = newwin(wlen,1,row,col);
	wattrset(win,COLOR_PAIR(color));
	p_i=i=0;
	p_wpos=wpos=0;
	strtop=0;
	while(1) {
		mvwaddch(win,p_wpos,0,str[p_i]);
		wattron(win,A_REVERSE);
		mvwaddch(win,wpos,0,str[i]);
		wattroff(win,A_REVERSE);
		wrefresh(win);
		napms(nap);
		p_i=i;
		p_wpos=wpos;
		wpos = ++wpos%wlen;
		i = ++i%len;
		if(!wpos) {
			strtop = ++strtop%len;
			i = strtop;
		}
	}
}
